#include <autodiff.hpp>

#define INTVARI

#if defined(INTVARI)
#define FILIB_EXTENDED
#include <interval/interval.hpp>
using namespace filib;
#endif


int main()
{
	#if defined(INTVARI)
	interval<double> I1(0.56,0.58);
	interval<double> I2(0.58,0.59);

	autodiff::autodiff<interval<double>,1> A = autodiff::autodiff<interval<double>,1>::constructVariable(I1);
	autodiff::autodiff<interval<double>,1> B = autodiff::autodiff<interval<double>,1>::constructVariable(I2);
	#else
	autodiff::autodiff<double,1> A = autodiff::autodiff<double,1>::constructVariable(0.5);
	autodiff::autodiff<double,1> B = autodiff::autodiff<double,1>::constructConstant(0.5);
	#endif

	std::cout << "A     :" << A << std::endl;
	std::cout << "B     :" << B << std::endl;
	std::cout << "A+B   :" << A+B << std::endl;
	std::cout << "A-B   :" << A-B << std::endl;
	std::cout << "A*B   :" << A*B << std::endl;

	std::cout << "sin(A):" << sin(A) << std::endl;
	std::cout << "cos(A):" << cos(A) << std::endl;
	std::cout << "tan(A):" << tan(A) << std::endl;
	std::cout << "cot(A):" << cot(A) << std::endl;
	std::cout << "asin(A):" << asin(A) << std::endl;
	std::cout << "acos(A):" << acos(A) << std::endl;
	std::cout << "atan(A):" << atan(A) << std::endl;
	
	#if defined(INTVARI)
	std::cout << "acot(A):" << acot(A) << std::endl;
	#endif

	std::cout << "sinh(A):" << sinh(A) << std::endl;
	std::cout << "cosh(A):" << cosh(A) << std::endl;
	std::cout << "tanh(A):" << tanh(A) << std::endl;
	// fehlt ??
	// std::cout << "coth(A):" << coth(A) << std::endl;

	#if defined(INTVARI)
	std::cout << "asinh(A):" << asinh(A) << std::endl;
	std::cout << "acosh(A):" << acosh(A) << std::endl;
	std::cout << "atanh(A):" << atanh(A) << std::endl;
	std::cout << "acoth(A):" << acoth(A) << std::endl;
	#endif
}
