REM create pathes
mkdir bin
mkdir lib
mkdir lib\DLL
mkdir lib\DLL\Release
mkdir lib\DLL\Debug

REM set flags for Release library
set RELEASECFLAGS=/O2 /I . /D "__i386__" /D "FILIB_DLL" /D "_WINDLL" /D "_MBCS" /FD /EHsc /MD /GS /GR /W3 /nologo /c /Wp64 /Zi /TP
set RELEASEOBJDIR=lib\DLL\Release\
set RELEASELDFLAGS=/DLL /INCREMENTAL:NO /MACHINE:X86 /NOLOGO /SUBSYSTEM:WINDOWS
set RELEASEDLL="lib\filib++.dll"

REM set flags for Debug library
set DEBUGCFLAGS=/Od /I . /D "__i386__" /D "FILIB_DLL" /D "_WINDLL" /D "_MBCS" /Gm /EHsc /RTC1 /MDd /GR /W3 /nologo /c /Wp64 /ZI /TP
set DEBUGOBJDIR=lib\DLL\Debug\
set DEBUGLDFLAGS=/DLL /INCREMENTAL:NO /MACHINE:X86 /NOLOGO /SUBSYSTEM:WINDOWS /DEBUG
set DEBUGDLL="lib\filib++d.dll"

REM set flags for Debug application
set DEBUGAPPCFLAGS=/Od /I . /D "__i386__" /Gm /EHsc /RTC1 /MDd /GR /W3 /nologo /c /Wp64 /ZI /TP
set DEBUGAPPOBJDIR=obj\debug\
set DEBUGAPPLDFLAGS=/INCREMENTAL:NO /MACHINE:X86 /NOLOGO /SUBSYSTEM:CONSOLE /DEBUG /LIBPATH:"lib"

REM set flags for Debug application
set RELEASEAPPCFLAGS=/O2 /I . /D "__i386__" /D "_MBCS" /FD /EHsc /MD /GS /GR /W3 /nologo /c /Wp64 /Zi /TP
set RELEASEAPPOBJDIR=obj\release\
set RELEASEAPPLDFLAGS=/INCREMENTAL:NO /MACHINE:X86 /NOLOGO /SUBSYSTEM:CONSOLE /LIBPATH:"lib"

REM compile Release library
cl  %RELEASECFLAGS% interval\stdfun\filib_consts.cpp /Fo"%RELEASEOBJDIR%filib_consts.obj"
cl  %RELEASECFLAGS% fp_traits\fp_traits_base_double_setup.cpp /Fo"%RELEASEOBJDIR%fp_traits_base_double_setup.obj"
cl  %RELEASECFLAGS% fp_traits\fp_traits_base_float_setup.cpp /Fo"%RELEASEOBJDIR%fp_traits_base_float_setup.obj"
cl  %RELEASECFLAGS% fp_traits\fp_traits_double_setup.cpp /Fo"%RELEASEOBJDIR%fp_traits_double_setup.obj"
cl  %RELEASECFLAGS% fp_traits\fp_traits_float_setup.cpp /Fo"%RELEASEOBJDIR%fp_traits_float_setup.obj"
cl  %RELEASECFLAGS% ieee\primitive.cpp /Fo"%RELEASEOBJDIR%primitive.obj"
cl  %RELEASECFLAGS% bsd\strtod_basic.cpp /Fo"%RELEASEOBJDIR%strtod_basic.obj"
cl  %RELEASECFLAGS% rounding_control\rounding_control_double_static.cpp /Fo"%RELEASEOBJDIR%rounding_control_double_static.obj"
cl  %RELEASECFLAGS% rounding_control\rounding_control_float_static.cpp /Fo"%RELEASEOBJDIR%rounding_control_float_static.obj"
REM link Release library
link %RELEASELDFLAGS% /OUT:%RELEASEDLL% %RELEASEOBJDIR%\*.obj

REM compile Debug library
cl  %DEBUGCFLAGS% interval\stdfun\filib_consts.cpp /Fo"%DEBUGOBJDIR%filib_consts.obj"
cl  %DEBUGCFLAGS% fp_traits\fp_traits_base_double_setup.cpp /Fo"%DEBUGOBJDIR%fp_traits_base_double_setup.obj"
cl  %DEBUGCFLAGS% fp_traits\fp_traits_base_float_setup.cpp /Fo"%DEBUGOBJDIR%fp_traits_base_float_setup.obj"
cl  %DEBUGCFLAGS% fp_traits\fp_traits_double_setup.cpp /Fo"%DEBUGOBJDIR%fp_traits_double_setup.obj"
cl  %DEBUGCFLAGS% fp_traits\fp_traits_float_setup.cpp /Fo"%DEBUGOBJDIR%fp_traits_float_setup.obj"
cl  %DEBUGCFLAGS% ieee\primitive.cpp /Fo"%DEBUGOBJDIR%primitive.obj"
cl  %DEBUGCFLAGS% bsd\strtod_basic.cpp /Fo"%DEBUGOBJDIR%strtod_basic.obj"
cl  %DEBUGCFLAGS% rounding_control\rounding_control_double_static.cpp /Fo"%DEBUGOBJDIR%rounding_control_double_static.obj"
cl  %DEBUGCFLAGS% rounding_control\rounding_control_float_static.cpp /Fo"%DEBUGOBJDIR%rounding_control_float_static.obj"
REM link Debug library
link %DEBUGLDFLAGS% /OUT:%DEBUGDLL% %DEBUGOBJDIR%\*.obj

rd /q /s lib\DLL

rd /q /s obj
mkdir obj
mkdir obj\debug
mkdir obj\release

cl %DEBUGAPPCFLAGS% /I . /I examples examples/testGauss.cc /Fo"%DEBUGAPPOBJDIR%\testGauss.obj"
link %DEBUGAPPLDFLAGS% /OUT:"bin\testGauss_d.exe" %DEBUGAPPOBJDIR%\testGauss.obj filib++d.lib

cl %DEBUGAPPCFLAGS% /I . /I examples examples/testNewton.cc /Fo"%DEBUGAPPOBJDIR%\testNewton.obj"
link %DEBUGAPPLDFLAGS% /OUT:"bin\testNewton_d.exe" %DEBUGAPPOBJDIR%\testNewton.obj filib++d.lib

cl %DEBUGAPPCFLAGS% /I . /I examples examples/xinewton.cc /Fo"%DEBUGAPPOBJDIR%\xinewton.obj"
link %DEBUGAPPLDFLAGS% /OUT:"bin\xinewton_d.exe" %DEBUGAPPOBJDIR%\xinewton.obj filib++d.lib

cl %DEBUGAPPCFLAGS% /I . /I examples examples/bisection.cc /Fo"%DEBUGAPPOBJDIR%\bisection.obj"
link %DEBUGAPPLDFLAGS% /OUT:"bin\bisection_d.exe" %DEBUGAPPOBJDIR%\bisection.obj filib++d.lib

cl %DEBUGAPPCFLAGS% /I . /I examples examples/comp_exp.cc /Fo"%DEBUGAPPOBJDIR%\comp_exp.obj"
link %DEBUGAPPLDFLAGS% /OUT:"bin\comp_exp_d.exe" %DEBUGAPPOBJDIR%\comp_exp.obj filib++d.lib

cl %DEBUGAPPCFLAGS% /I . /I examples examples/comp_sin.cc /Fo"%DEBUGAPPOBJDIR%\comp_sin.obj"
link %DEBUGAPPLDFLAGS% /OUT:"bin\comp_sin_d.exe" %DEBUGAPPOBJDIR%\comp_sin.obj filib++d.lib

cl %DEBUGAPPCFLAGS% /I . /I examples examples/horner.cc /Fo"%DEBUGAPPOBJDIR%\horner.obj"
link %DEBUGAPPLDFLAGS% /OUT:"bin\horner_d.exe" %DEBUGAPPOBJDIR%\horner.obj filib++d.lib

cl %DEBUGAPPCFLAGS% /I . /I examples examples/simple_example1.cpp /Fo"%DEBUGAPPOBJDIR%\simple_example1.obj"
link %DEBUGAPPLDFLAGS% /OUT:"bin\simple_example1_d.exe" %DEBUGAPPOBJDIR%\simple_example1.obj filib++d.lib

cl %DEBUGAPPCFLAGS% /I . /I examples examples/example_template.cpp /Fo"%DEBUGAPPOBJDIR%\example_template.obj"
link %DEBUGAPPLDFLAGS% /OUT:"bin\example_template_d.exe" %DEBUGAPPOBJDIR%\example_template.obj filib++d.lib

cl %DEBUGAPPCFLAGS% /I . benchmark/corebench.cpp /Fo"%DEBUGAPPOBJDIR%\corebench.obj"
link %DEBUGAPPLDFLAGS% /OUT:"bin\corebench_d.exe" %DEBUGAPPOBJDIR%\corebench.obj filib++d.lib


rem Releaseversionen
cl %RELEASEAPPCFLAGS% /I . /I examples examples/testGauss.cc /Fo"%RELEASEAPPOBJDIR%\testGauss.obj"
link %RELEASEAPPLDFLAGS% /OUT:"bin\testGauss.exe" %RELEASEAPPOBJDIR%\testGauss.obj filib++.lib

cl %RELEASEAPPCFLAGS% /I . /I examples examples/testNewton.cc /Fo"%RELEASEAPPOBJDIR%\testNewton.obj"
link %RELEASEAPPLDFLAGS% /OUT:"bin\testNewton.exe" %RELEASEAPPOBJDIR%\testNewton.obj filib++.lib

cl %RELEASEAPPCFLAGS% /I . /I examples examples/xinewton.cc /Fo"%RELEASEAPPOBJDIR%\xinewton.obj"
link %RELEASEAPPLDFLAGS% /OUT:"bin\xinewton.exe" %RELEASEAPPOBJDIR%\xinewton.obj filib++.lib

cl %RELEASEAPPCFLAGS% /I . /I examples examples/bisection.cc /Fo"%RELEASEAPPOBJDIR%\bisection.obj"
link %RELEASEAPPLDFLAGS% /OUT:"bin\bisection.exe" %RELEASEAPPOBJDIR%\bisection.obj filib++.lib

cl %RELEASEAPPCFLAGS% /I . /I examples examples/comp_exp.cc /Fo"%RELEASEAPPOBJDIR%\comp_exp.obj"
link %RELEASEAPPLDFLAGS% /OUT:"bin\comp_exp.exe" %RELEASEAPPOBJDIR%\comp_exp.obj filib++.lib

cl %RELEASEAPPCFLAGS% /I . /I examples examples/comp_sin.cc /Fo"%RELEASEAPPOBJDIR%\comp_sin.obj"
link %RELEASEAPPLDFLAGS% /OUT:"bin\comp_sin.exe" %RELEASEAPPOBJDIR%\comp_sin.obj filib++.lib

cl %RELEASEAPPCFLAGS% /I . /I examples examples/horner.cc /Fo"%RELEASEAPPOBJDIR%\horner.obj"
link %RELEASEAPPLDFLAGS% /OUT:"bin\horner.exe" %RELEASEAPPOBJDIR%\horner.obj filib++.lib

cl %RELEASEAPPCFLAGS% /I . /I examples examples/simple_example1.cpp /Fo"%RELEASEAPPOBJDIR%\simple_example1.obj"
link %RELEASEAPPLDFLAGS% /OUT:"bin\simple_example1.exe" %RELEASEAPPOBJDIR%\simple_example1.obj filib++.lib

cl %RELEASEAPPCFLAGS% /I . /I examples examples/example_template.cpp /Fo"%RELEASEAPPOBJDIR%\example_template.obj"
link %RELEASEAPPLDFLAGS% /OUT:"bin\example_template.exe" %RELEASEAPPOBJDIR%\example_template.obj filib++.lib

cl %RELEASEAPPCFLAGS% /I . benchmark/corebench.cpp /Fo"%RELEASEAPPOBJDIR%\corebench.obj"
link %RELEASEAPPLDFLAGS% /OUT:"bin\corebench.exe" %RELEASEAPPOBJDIR%\corebench.obj filib++.lib


REM
REM Tests
REM

cl %DEBUGAPPCFLAGS% /I . test/makeTestCases.cpp /Fo"%DEBUGAPPOBJDIR%\makeTestCases.obj"
cl %DEBUGAPPCFLAGS% /I . test/stdFunTestCases.cpp /Fo"%DEBUGAPPOBJDIR%\stdFunTestCases.obj"
link %DEBUGAPPLDFLAGS% /OUT:"bin\makeTestCases_d.exe" %DEBUGAPPOBJDIR%\makeTestCases.obj %DEBUGAPPOBJDIR%\stdFunTestCases.obj filib++d.lib

mkdir log
set path=lib;%path%
bin\makeTestCases_d.exe > log\makeTestCasesLog.txt


cl %DEBUGAPPCFLAGS% /D FILIB_EXTENDED /I . test/check_0f.cpp /Fo"%DEBUGAPPOBJDIR%\check_0f.obj"
link %DEBUGAPPLDFLAGS% /OUT:"bin\check_0f_d.exe" %DEBUGAPPOBJDIR%\check_0f.obj filib++d.lib

cl %DEBUGAPPCFLAGS% /D FILIB_EXTENDED /I . test/check_0t.cpp /Fo"%DEBUGAPPOBJDIR%\check_0t.obj"
link %DEBUGAPPLDFLAGS% /OUT:"bin\check_0t_d.exe" %DEBUGAPPOBJDIR%\check_0t.obj filib++d.lib

cl %DEBUGAPPCFLAGS% /D FILIB_EXTENDED /I . test/check_1f.cpp /Fo"%DEBUGAPPOBJDIR%\check_1f.obj"
link %DEBUGAPPLDFLAGS% /OUT:"bin\check_1f_d.exe" %DEBUGAPPOBJDIR%\check_1f.obj filib++d.lib

cl %DEBUGAPPCFLAGS% /D FILIB_EXTENDED /I . test/check_2f.cpp /Fo"%DEBUGAPPOBJDIR%\check_2f.obj"
link %DEBUGAPPLDFLAGS% /OUT:"bin\check_2f_d.exe" %DEBUGAPPOBJDIR%\check_2f.obj filib++d.lib

cl %DEBUGAPPCFLAGS% /D FILIB_EXTENDED /I . test/check_3t.cpp /Fo"%DEBUGAPPOBJDIR%\check_3t.obj"
link %DEBUGAPPLDFLAGS% /OUT:"bin\check_3t_d.exe" %DEBUGAPPOBJDIR%\check_3t.obj filib++d.lib

cl %DEBUGAPPCFLAGS% /D FILIB_EXTENDED /I . test/check_4f.cpp /Fo"%DEBUGAPPOBJDIR%\check_4f.obj"
link %DEBUGAPPLDFLAGS% /OUT:"bin\check_4f_d.exe" %DEBUGAPPOBJDIR%\check_4f.obj filib++d.lib

cl %DEBUGAPPCFLAGS% /D FILIB_EXTENDED /I . test/check_5f.cpp /Fo"%DEBUGAPPOBJDIR%\check_5f.obj"
link %DEBUGAPPLDFLAGS% /OUT:"bin\check_5f_d.exe" %DEBUGAPPOBJDIR%\check_5f.obj filib++d.lib

cl %RELEASEAPPCFLAGS% /D FILIB_EXTENDED /I . test/check_0f.cpp /Fo"%RELEASEAPPOBJDIR%\check_0f.obj"
link %RELEASEAPPLDFLAGS% /OUT:"bin\check_0f.exe" %RELEASEAPPOBJDIR%\check_0f.obj filib++.lib

cl %RELEASEAPPCFLAGS% /D FILIB_EXTENDED /I . test/check_0t.cpp /Fo"%RELEASEAPPOBJDIR%\check_0t.obj"
link %RELEASEAPPLDFLAGS% /OUT:"bin\check_0t.exe" %RELEASEAPPOBJDIR%\check_0t.obj filib++.lib

cl %RELEASEAPPCFLAGS% /D FILIB_EXTENDED /I . test/check_1f.cpp /Fo"%RELEASEAPPOBJDIR%\check_1f.obj"
link %RELEASEAPPLDFLAGS% /OUT:"bin\check_1f.exe" %RELEASEAPPOBJDIR%\check_1f.obj filib++.lib

cl %RELEASEAPPCFLAGS% /D FILIB_EXTENDED /I . test/check_2f.cpp /Fo"%RELEASEAPPOBJDIR%\check_2f.obj"
link %RELEASEAPPLDFLAGS% /OUT:"bin\check_2f.exe" %RELEASEAPPOBJDIR%\check_2f.obj filib++.lib

cl %RELEASEAPPCFLAGS% /D FILIB_EXTENDED /I . test/check_3t.cpp /Fo"%RELEASEAPPOBJDIR%\check_3t.obj"
link %RELEASEAPPLDFLAGS% /OUT:"bin\check_3t.exe" %RELEASEAPPOBJDIR%\check_3t.obj filib++.lib

cl %RELEASEAPPCFLAGS% /D FILIB_EXTENDED /I . test/check_4f.cpp /Fo"%RELEASEAPPOBJDIR%\check_4f.obj"
link %RELEASEAPPLDFLAGS% /OUT:"bin\check_4f.exe" %RELEASEAPPOBJDIR%\check_4f.obj filib++.lib

cl %RELEASEAPPCFLAGS% /D FILIB_EXTENDED /I . test/check_5f.cpp /Fo"%RELEASEAPPOBJDIR%\check_5f.obj"
link %RELEASEAPPLDFLAGS% /OUT:"bin\check_5f.exe" %RELEASEAPPOBJDIR%\check_5f.obj filib++.lib
