/*                                                                           
**  fi_lib++  --- A fast interval library (Version 2.0)                     
**                                                                  
**  Copyright (C) 2001:                                                        
**                                                     
**  Werner Hofschuster, Walter Kraemer                               
**  Wissenschaftliches Rechnen/Softwaretechnologie (WRSWT)  
**  Universitaet Wuppertal, Germany                                           
**  Michael Lerch, German Tischler, Juergen Wolff von Gudenberg       
**  Institut fuer Informatik                                         
**  Universitaet Wuerzburg, Germany                                           
** 
**  This library is free software; you can redistribute it and/or
**  modify it under the terms of the GNU Library General Public
**  License as published by the Free Software Foundation; either
**  version 2 of the License, or (at your option) any later version.
**
**  This library is distributed in the hope that it will be useful,
**  but WITHOUT ANY WARRANTY; without even the implied warranty of
**  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
**  Library General Public License for more details.
**
**  You should have received a copy of the GNU Library General Public
**  License along with this library; if not, write to the Free
**  Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307 USA
*/
#include "rounding_control/rounding_control.hpp"

/**
  namespace for fast interval library
 */
template <>
unsigned short filib::rounding_control<float,false>::s_i387_FLOAT_ROUND_NEAR = 0x007F;
template <>
unsigned short filib::rounding_control<float,false>::s_i387_FLOAT_ROUND_DOWN = 0x047F;
template <>
unsigned short filib::rounding_control<float,false>::s_i387_FLOAT_ROUND_UP = 0x087F;
template <>
unsigned short filib::rounding_control<float,false>::s_i387_FLOAT_ROUND_TRUNC = 0x0C7F;

template <>
unsigned short filib::rounding_control<float,true>::s_i387_FLOAT_ROUND_NEAR = 0x007F;
template <>
unsigned short filib::rounding_control<float,true>::s_i387_FLOAT_ROUND_DOWN = 0x047F;
template <>
unsigned short filib::rounding_control<float,true>::s_i387_FLOAT_ROUND_UP = 0x087F;
template <>
unsigned short filib::rounding_control<float,true>::s_i387_FLOAT_ROUND_TRUNC = 0x0C7F;
