/*                                                                           
**  fi_lib++  --- A fast interval library (Version 2.0)                     
**                                                                  
**  Copyright (C) 2001:                                                        
**                                                     
**  Werner Hofschuster, Walter Kraemer                               
**  Wissenschaftliches Rechnen/Softwaretechnologie (WRSWT)  
**  Universitaet Wuppertal, Germany                                           
**  Michael Lerch, German Tischler, Juergen Wolff von Gudenberg       
**  Institut fuer Informatik                                         
**  Universitaet Wuerzburg, Germany                                           
** 
**  This library is free software; you can redistribute it and/or
**  modify it under the terms of the GNU Library General Public
**  License as published by the Free Software Foundation; either
**  version 2 of the License, or (at your option) any later version.
**
**  This library is distributed in the hope that it will be useful,
**  but WITHOUT ANY WARRANTY; without even the implied warranty of
**  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
**  Library General Public License for more details.
**
**  You should have received a copy of the GNU Library General Public
**  License along with this library; if not, write to the Free
**  Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307 USA
*/
#include "rounding_control/rounding_control.hpp"
#include "ieee/primitive.hpp"

#include <cmath>
#include <cfloat>
#include <iostream>

void fun(double f, double g)
{
        std::cout << " [ ";
        filib::primitive::basicBitImage(f,std::cout);
        std::cout << " ]" << "(" << f << ")" << "\n";
        std::cout << "+[ ";
        filib::primitive::basicBitImage(g,std::cout);
        std::cout << " ]" << "(" << g << ")" << "\n";
        std::cout << "=[ ";
        filib::primitive::basicBitImage(f+g,std::cout);
        std::cout << " ]" << "(" << f+g << ")" << "\n\n";
}

void fung(double f, double g)
{
        std::cout << "NEAR, DOWN, UP, ZERO" << std::endl;

        filib::rounding_control<double,false>::tonearest();
        fun(f,g);
        filib::rounding_control<double,false>::downward();
        fun(f,g);
        filib::rounding_control<double,false>::upward();
        fun(f,g);
        filib::rounding_control<double,false>::tozero();
        fun(f,g);
}

void mfun(double f, double g)
{
        std::cout << " [ ";
        filib::primitive::basicBitImage(f,std::cout);
        std::cout << " ]" << "(" << f << ")" << "\n";
        std::cout << "*[ ";
        filib::primitive::basicBitImage(g,std::cout);
        std::cout << " ]" << "(" << g << ")" << "\n";
        std::cout << "=[ ";
        filib::primitive::basicBitImage(f*g,std::cout);
        std::cout << " ]" << "(" << f*g << ")" << "\n\n";
}

void mfung(double f, double g)
{
        std::cout << "NEAR, DOWN, UP, ZERO" << std::endl;

        filib::rounding_control<double,false>::tonearest();
        mfun(f,g);
        filib::rounding_control<double,false>::downward();
        mfun(f,g);
        filib::rounding_control<double,false>::upward();
        mfun(f,g);
        filib::rounding_control<double,false>::tozero();
        mfun(f,g);
}

int main()
{
	double f = 1.0, g = DBL_MAX;
	fung(f,g);
	f = -1.0, g = -DBL_MAX;
	fung(f,g);
	f = filib::primitive::compose(1,0,0,1);
	g = 0.8;
	mfung(f,g);
}
